Program IEMSI_information;

{----------------------------------------------------------------------------}
{-        A small utility you can use at your RemoteAccess BBS system       -}
{-                                                                          -}
{- It will show the IEMSI information that RA knowns about the users system -}
{-                                                                          -}
{- Create a menu called IEMSI with 3 menu-items that are is automatic (^A)  -}
{-                                                                          -}
{- 1:  Type  7 : C:\BBS\IEMSI.EXE C:\BBS\TEXT\IEMSI.ASC                     -}
{- 2:  Type 45 : IEMSI                                                      -}
{- 3:  Type  3 : Return from gosub                                          -}
{-                                                                          -}
{----------------------------------------------------------------------------}


Uses Crt;

{$I STRUCT.110} { This file is inside the RA_111.ARJ package }

Var
 E  : ExitInfoRecord;
 EF : File of ExitInfoRecord;

Begin

  If ParamCount<>1 Then
  Begin
    WriteLn(#10#10#13'IEMSI Information');
    WriteLn('Syntax: IEMSI C:\BBS\TEXT\IEMSI.ASC');
    Delay(2000);
    Halt;
  End;

  Assign(EF,'EXITINFO.BBS');
  {$I-} Reset(EF); {$I+}
  If IOResult<>0 Then
  Begin
    WriteLn('Error opening EXITINFO.BBS in current directory');
    Delay(2000);
    Halt;
  End;
  Read(EF,E);
  Close(EF);

  Assign(Output,ParamStr(1));
  {$I-} Rewrite(Output); {$I+}
  If IOResult<>0 Then
  Begin
    WriteLn('Error writing output file');
    Delay(2000);
    Halt;
  End;

  WriteLn(Output,' IEMSI Information by Bo TERMINATE Bendtsen');
  WriteLn(Output,''+#10);

  If E.EMSI_session then
  Begin
    WriteLn('IEMSI Console defaults : '+E.EMSI_Crtdef);
    WriteLn('IEMSI protocol options : '+E.EMSI_Protocols);
    WriteLn('IEMSI Capabilities     : '+E.EMSI_Capabilities);
    WriteLn('IEMSI Requests         : '+E.EMSI_Requests);
    WriteLn('IEMSI Software         : '+E.EMSI_Software);
  End
  Else Begin
    WriteLn('You must use a program with IEMSI, like Terminate to use this function');
  End;
  WriteLn(Output,''+#10);
  Close(Output);
End.
